diff --git a/doc/src/sgml/logical-replication.sgml b/doc/src/sgml/logical-replication.sgml
index b3faaa675ef..f145d60fcf1 100644
--- a/doc/src/sgml/logical-replication.sgml
+++ b/doc/src/sgml/logical-replication.sgml
@@ -96,7 +96,7 @@
   subscribers to the same set of tables, conflicts can arise.
  </para>
 
- <sect1 id="logical-replication-publication">
+ <sect1 id="logical-replication-publication" xreflabel="Publication">
   <title>Publication</title>
 
   <para>
@@ -146,7 +146,7 @@
    snapshot once the transaction has committed.
   </para>
 
-  <sect2 id="logical-replication-publication-replica-identity">
+  <sect2 id="logical-replication-publication-replica-identity" xreflabel="Replica Identity">
    <title>Replica Identity</title>
 
    <para>
@@ -200,7 +200,7 @@
 
  </sect1>
 
- <sect1 id="logical-replication-subscription">
+ <sect1 id="logical-replication-subscription" xreflabel="Subscription">
   <title>Subscription</title>
 
   <para>
@@ -289,7 +289,7 @@
    option of <command>CREATE SUBSCRIPTION</command> for details.
   </para>
 
-  <sect2 id="logical-replication-subscription-slot">
+  <sect2 id="logical-replication-subscription-slot" xreflabel="Logical Replication Slot Management">
    <title>Logical Replication Slot Management</title>
 
    <para>
@@ -364,7 +364,7 @@
    </para>
   </sect2>
 
-  <sect2 id="logical-replication-subscription-examples">
+  <sect2 id="logical-replication-subscription-examples" xreflabel="Examples: Set Up Logical Replication">
     <title>Examples: Set Up Logical Replication</title>
 
     <para>
@@ -539,7 +539,7 @@
 </programlisting></para>
   </sect2>
 
-  <sect2 id="logical-replication-subscription-examples-deferred-slot">
+  <sect2 id="logical-replication-subscription-examples-deferred-slot" xreflabel="Examples: Deferred Logical Replication Slot Creation">
    <title>Examples: Deferred Logical Replication Slot Creation</title>
 
    <para>
@@ -689,7 +689,7 @@ HINT:  To initiate replication, you must manually create the replication slot, e
 
  </sect1>
 
- <sect1 id="logical-replication-failover">
+ <sect1 id="logical-replication-failover" xreflabel="Logical Replication Failover">
   <title>Logical Replication Failover</title>
 
   <para>
@@ -827,7 +827,7 @@ HINT:  To initiate replication, you must manually create the replication slot, e
 </programlisting></para>
  </sect1>
 
- <sect1 id="logical-replication-row-filter">
+ <sect1 id="logical-replication-row-filter" xreflabel="Row Filters">
   <title>Row Filters</title>
 
   <para>
@@ -843,7 +843,7 @@ HINT:  To initiate replication, you must manually create the replication slot, e
    <xref linkend="sql-createpublication"/> for details.
   </para>
 
-  <sect2 id="logical-replication-row-filter-rules">
+  <sect2 id="logical-replication-row-filter-rules" xreflabel="Row Filter Rules">
    <title>Row Filter Rules</title>
 
    <para>
@@ -859,7 +859,7 @@ HINT:  To initiate replication, you must manually create the replication slot, e
 
   </sect2>
 
-  <sect2 id="logical-replication-row-filter-restrictions">
+  <sect2 id="logical-replication-row-filter-restrictions" xreflabel="Expression Restrictions">
    <title>Expression Restrictions</title>
 
    <para>
@@ -879,7 +879,7 @@ HINT:  To initiate replication, you must manually create the replication slot, e
 
   </sect2>
 
-  <sect2 id="logical-replication-row-filter-transformations">
+  <sect2 id="logical-replication-row-filter-transformations" xreflabel="UPDATE Transformations">
    <title>UPDATE Transformations</title>
 
    <para>
@@ -940,7 +940,7 @@ HINT:  To initiate replication, you must manually create the replication slot, e
 
   </sect2>
 
-  <sect2 id="logical-replication-row-filter-partitioned-table">
+  <sect2 id="logical-replication-row-filter-partitioned-table" xreflabel="Partitioned Tables">
    <title>Partitioned Tables</title>
 
    <para>
@@ -955,7 +955,7 @@ HINT:  To initiate replication, you must manually create the replication slot, e
 
   </sect2>
 
-  <sect2 id="logical-replication-row-filter-initial-data-sync">
+  <sect2 id="logical-replication-row-filter-initial-data-sync" xreflabel="Initial Data Synchronization">
    <title>Initial Data Synchronization</title>
 
    <para>
@@ -992,7 +992,7 @@ HINT:  To initiate replication, you must manually create the replication slot, e
 
   </sect2>
 
-  <sect2 id="logical-replication-row-filter-combining">
+  <sect2 id="logical-replication-row-filter-combining" xreflabel="Combining Multiple Row Filters">
    <title>Combining Multiple Row Filters</title>
 
    <para>
@@ -1027,7 +1027,7 @@ HINT:  To initiate replication, you must manually create the replication slot, e
 
   </sect2>
 
-  <sect2 id="logical-replication-row-filter-examples">
+  <sect2 id="logical-replication-row-filter-examples" xreflabel="Examples">
    <title>Examples</title>
 
    <para>
@@ -1375,7 +1375,7 @@ Publications:
 
  </sect1>
 
- <sect1 id="logical-replication-col-lists">
+ <sect1 id="logical-replication-col-lists" xreflabel="Column Lists">
   <title>Column Lists</title>
 
   <para>
@@ -1475,7 +1475,7 @@ Publications:
     </para>
    </warning>
 
-  <sect2 id="logical-replication-col-list-examples">
+  <sect2 id="logical-replication-col-list-examples" xreflabel="Examples">
    <title>Examples</title>
 
    <para>
@@ -1571,7 +1571,7 @@ Publications:
 
  </sect1>
 
- <sect1 id="logical-replication-gencols">
+ <sect1 id="logical-replication-gencols" xreflabel="Generated Column Replication">
   <title>Generated Column Replication</title>
 
   <para>
@@ -1750,7 +1750,7 @@ Publications:
   </note>
  </sect1>
 
- <sect1 id="logical-replication-sequences">
+ <sect1 id="logical-replication-sequences" xreflabel="Replicating Sequences">
   <title>Replicating Sequences</title>
 
   <para>
@@ -1797,7 +1797,7 @@ Publications:
    configuration.
   </para>
 
-  <sect2 id="sequence-definition-mismatches">
+  <sect2 id="sequence-definition-mismatches" xreflabel="Sequence Definition Mismatches">
    <title>Sequence Definition Mismatches</title>
    <para>
     The sequence synchronization worker validates that sequence definitions
@@ -1814,7 +1814,7 @@ Publications:
    </para>
   </sect2>
 
-  <sect2 id="sequences-out-of-sync">
+  <sect2 id="sequences-out-of-sync" xreflabel="Refreshing Out-of-Sync Sequences">
    <title>Refreshing Out-of-Sync Sequences</title>
    <para>
     Subscriber sequence values will become out of sync as the publisher
@@ -1841,7 +1841,7 @@ Publications:
    </warning>
   </sect2>
 
-  <sect2 id="logical-replication-sequences-examples">
+  <sect2 id="logical-replication-sequences-examples" xreflabel="Examples">
    <title>Examples</title>
 
    <para>
@@ -1991,7 +1991,7 @@ Publications:
   </sect2>
  </sect1>
 
- <sect1 id="logical-replication-conflicts">
+ <sect1 id="logical-replication-conflicts" xreflabel="Conflicts">
   <title>Conflicts</title>
 
   <para>
@@ -2310,7 +2310,7 @@ CONTEXT:  processing remote data for replication origin "pg_16395" during "INSER
   </para>
  </sect1>
 
- <sect1 id="logical-replication-restrictions">
+ <sect1 id="logical-replication-restrictions" xreflabel="Restrictions">
   <title>Restrictions</title>
 
   <para>
@@ -2415,7 +2415,7 @@ CONTEXT:  processing remote data for replication origin "pg_16395" during "INSER
   </itemizedlist>
  </sect1>
 
- <sect1 id="logical-replication-architecture">
+ <sect1 id="logical-replication-architecture" xreflabel="Architecture">
   <title>Architecture</title>
 
   <para>
@@ -2452,7 +2452,7 @@ CONTEXT:  processing remote data for replication origin "pg_16395" during "INSER
    and statement triggers for <command>INSERT</command>.
   </para>
 
-  <sect2 id="logical-replication-snapshot">
+  <sect2 id="logical-replication-snapshot" xreflabel="Initial Snapshot">
     <title>Initial Snapshot</title>
     <para>
      The initial data in existing subscribed tables are snapshotted and
@@ -2492,7 +2492,7 @@ CONTEXT:  processing remote data for replication origin "pg_16395" during "INSER
   </sect2>
  </sect1>
 
- <sect1 id="logical-replication-monitoring">
+ <sect1 id="logical-replication-monitoring" xreflabel="Monitoring">
   <title>Monitoring</title>
 
   <para>
@@ -2523,7 +2523,7 @@ CONTEXT:  processing remote data for replication origin "pg_16395" during "INSER
   </para>
  </sect1>
 
- <sect1 id="logical-replication-security">
+ <sect1 id="logical-replication-security" xreflabel="Security">
   <title>Security</title>
 
   <para>
@@ -2616,7 +2616,7 @@ CONTEXT:  processing remote data for replication origin "pg_16395" during "INSER
   </para>
  </sect1>
 
- <sect1 id="logical-replication-config">
+ <sect1 id="logical-replication-config" xreflabel="Configuration Settings">
   <title>Configuration Settings</title>
 
   <para>
@@ -2624,7 +2624,7 @@ CONTEXT:  processing remote data for replication origin "pg_16395" during "INSER
    options are relevant only on one side of the replication.
   </para>
 
-  <sect2 id="logical-replication-config-publisher">
+  <sect2 id="logical-replication-config-publisher" xreflabel="Publishers">
    <title>Publishers</title>
 
    <para>
@@ -2657,7 +2657,7 @@ CONTEXT:  processing remote data for replication origin "pg_16395" during "INSER
 
   </sect2>
 
-  <sect2 id="logical-replication-config-subscriber">
+  <sect2 id="logical-replication-config-subscriber" xreflabel="Subscribers">
    <title>Subscribers</title>
 
    <para>
@@ -2712,7 +2712,7 @@ CONTEXT:  processing remote data for replication origin "pg_16395" during "INSER
 
  </sect1>
 
- <sect1 id="logical-replication-upgrade">
+ <sect1 id="logical-replication-upgrade" xreflabel="Upgrade">
   <title>Upgrade</title>
 
   <para>
@@ -2721,7 +2721,7 @@ CONTEXT:  processing remote data for replication origin "pg_16395" during "INSER
    clusters are version 17.0 or later.
   </para>
 
-  <sect2 id="prepare-publisher-upgrades">
+  <sect2 id="prepare-publisher-upgrades" xreflabel="Prepare for Publisher Upgrades">
    <title>Prepare for Publisher Upgrades</title>
 
    <para>
@@ -2793,7 +2793,7 @@ CONTEXT:  processing remote data for replication origin "pg_16395" during "INSER
    </itemizedlist>
   </sect2>
 
-  <sect2 id="prepare-subscriber-upgrades">
+  <sect2 id="prepare-subscriber-upgrades" xreflabel="Prepare for Subscriber Upgrades">
    <title>Prepare for Subscriber Upgrades</title>
 
    <para>
@@ -2869,7 +2869,7 @@ CONTEXT:  processing remote data for replication origin "pg_16395" during "INSER
    </itemizedlist>
   </sect2>
 
-  <sect2 id="upgrading-logical-replication-clusters">
+  <sect2 id="upgrading-logical-replication-clusters" xreflabel="Upgrading Logical Replication Clusters">
    <title>Upgrading Logical Replication Clusters</title>
 
    <para>
@@ -2933,7 +2933,7 @@ CONTEXT:  processing remote data for replication origin "pg_16395" during "INSER
     </itemizedlist>
    </para>
 
-   <sect3 id="steps-two-node-logical-replication-cluster">
+   <sect3 id="steps-two-node-logical-replication-cluster" xreflabel="Steps to Upgrade a Two-node Logical Replication Cluster">
     <title>Steps to Upgrade a Two-node Logical Replication Cluster</title>
      <para>
       Let's say publisher is in <literal>node1</literal> and subscriber is
@@ -3077,7 +3077,7 @@ pg_ctl -D /opt/PostgreSQL/data2_upgraded start -l logfile
      </note>
     </sect3>
 
-    <sect3 id="steps-cascaded-logical-replication-cluster">
+    <sect3 id="steps-cascaded-logical-replication-cluster" xreflabel="Steps to Upgrade a Cascaded Logical Replication Cluster">
      <title>Steps to Upgrade a Cascaded Logical Replication Cluster</title>
      <para>
       Let's say we have a cascaded logical replication setup
@@ -3306,7 +3306,7 @@ pg_ctl -D /opt/PostgreSQL/data3_upgraded start -l logfile
      </procedure>
     </sect3>
 
-    <sect3 id="steps-two-node-circular-logical-replication-cluster">
+    <sect3 id="steps-two-node-circular-logical-replication-cluster" xreflabel="Steps to Upgrade a Two-node Circular Logical Replication Cluster">
      <title>Steps to Upgrade a Two-node Circular Logical Replication Cluster</title>
      <para>
       Let's say we have a circular logical replication setup
@@ -3501,7 +3501,7 @@ pg_ctl -D /opt/PostgreSQL/data2_upgraded start -l logfile
    </sect2>
  </sect1>
 
- <sect1 id="logical-replication-quick-setup">
+ <sect1 id="logical-replication-quick-setup" xreflabel="Quick Setup">
   <title>Quick Setup</title>
 
   <para>
diff --git a/doc/src/sgml/logicaldecoding.sgml b/doc/src/sgml/logicaldecoding.sgml
index 6368e46ce93..636ff80d8e4 100644
--- a/doc/src/sgml/logicaldecoding.sgml
+++ b/doc/src/sgml/logicaldecoding.sgml
@@ -37,7 +37,7 @@
    (see <xref linkend="logicaldecoding-writer"/>).
   </para>
 
-  <sect1 id="logicaldecoding-example">
+  <sect1 id="logicaldecoding-example" xreflabel="Logical Decoding Examples">
    <title>Logical Decoding Examples</title>
 
    <para>
@@ -235,9 +235,9 @@ postgres=# SELECT * from pg_logical_slot_get_changes('regression_slot', NULL, NU
 </programlisting>
 </sect1>
 
-  <sect1 id="logicaldecoding-explanation">
+  <sect1 id="logicaldecoding-explanation" xreflabel="Logical Decoding Concepts">
    <title>Logical Decoding Concepts</title>
-   <sect2 id="logicaldecoding-explanation-log-dec">
+   <sect2 id="logicaldecoding-explanation-log-dec" xreflabel="Logical Decoding">
     <title>Logical Decoding</title>
 
     <indexterm>
@@ -259,7 +259,7 @@ postgres=# SELECT * from pg_logical_slot_get_changes('regression_slot', NULL, NU
     </para>
    </sect2>
 
-   <sect2 id="logicaldecoding-replication-slots">
+   <sect2 id="logicaldecoding-replication-slots" xreflabel="Replication Slots">
     <title>Replication Slots</title>
 
     <indexterm>
@@ -361,7 +361,7 @@ postgres=# SELECT * from pg_logical_slot_get_changes('regression_slot', NULL, NU
 
    </sect2>
 
-   <sect2 id="logicaldecoding-replication-slots-synchronization">
+   <sect2 id="logicaldecoding-replication-slots-synchronization" xreflabel="Replication Slot Synchronization">
     <title>Replication Slot Synchronization</title>
     <para>
      The logical replication slots on the primary can be synchronized to
@@ -475,7 +475,7 @@ DETAIL:  Synchronization could lead to data loss, because the remote slot needs
     </caution>
    </sect2>
 
-   <sect2 id="logicaldecoding-explanation-output-plugins">
+   <sect2 id="logicaldecoding-explanation-output-plugins" xreflabel="Output Plugins">
     <title>Output Plugins</title>
     <para>
      Output plugins transform the data from the write-ahead log's internal
@@ -483,7 +483,7 @@ DETAIL:  Synchronization could lead to data loss, because the remote slot needs
     </para>
    </sect2>
 
-   <sect2 id="logicaldecoding-explanation-exported-snapshots">
+   <sect2 id="logicaldecoding-explanation-exported-snapshots" xreflabel="Exported Snapshots">
     <title>Exported Snapshots</title>
     <para>
      When a new replication slot is created using the streaming replication
@@ -506,7 +506,7 @@ DETAIL:  Synchronization could lead to data loss, because the remote slot needs
    </sect2>
   </sect1>
 
-  <sect1 id="logicaldecoding-walsender">
+  <sect1 id="logicaldecoding-walsender" xreflabel="Streaming Replication Protocol Interface">
    <title>Streaming Replication Protocol Interface</title>
 
    <para>
@@ -537,7 +537,7 @@ DETAIL:  Synchronization could lead to data loss, because the remote slot needs
    </para>
   </sect1>
 
-  <sect1 id="logicaldecoding-sql">
+  <sect1 id="logicaldecoding-sql" xreflabel="Logical Decoding SQL Interface">
    <title>Logical Decoding <acronym>SQL</acronym> Interface</title>
 
    <para>
@@ -553,7 +553,7 @@ DETAIL:  Synchronization could lead to data loss, because the remote slot needs
    </para>
   </sect1>
 
-  <sect1 id="logicaldecoding-catalogs">
+  <sect1 id="logicaldecoding-catalogs" xreflabel="System Catalogs Related to Logical Decoding">
    <title>System Catalogs Related to Logical Decoding</title>
 
    <para>
@@ -570,7 +570,7 @@ DETAIL:  Synchronization could lead to data loss, because the remote slot needs
    </para>
   </sect1>
 
-  <sect1 id="logicaldecoding-output-plugin">
+  <sect1 id="logicaldecoding-output-plugin" xreflabel="Logical Decoding Output Plugins">
    <title>Logical Decoding Output Plugins</title>
 
    <para>
@@ -594,7 +594,7 @@ DETAIL:  Synchronization could lead to data loss, because the remote slot needs
      logical replication</link>.
     </para>
 
-    <sect3 id="logicaldecoding-pgoutput-options">
+    <sect3 id="logicaldecoding-pgoutput-options" xreflabel="Options">
      <title>Options</title>
 
      <variablelist>
@@ -717,7 +717,7 @@ DETAIL:  Synchronization could lead to data loss, because the remote slot needs
 
     </sect3>
 
-    <sect3 id="logicaldecoding-pgoutput-notes">
+    <sect3 id="logicaldecoding-pgoutput-notes" xreflabel="Notes">
      <title>Notes</title>
 
      <para>
@@ -734,7 +734,7 @@ DETAIL:  Synchronization could lead to data loss, because the remote slot needs
    </sect2>
   </sect1>
 
-  <sect1 id="logicaldecoding-output-plugin-writing">
+  <sect1 id="logicaldecoding-output-plugin-writing" xreflabel="Writing Logical Decoding Output Plugins">
    <title>Writing Logical Decoding Output Plugins</title>
    <para>
     An example output plugin can be found in the
@@ -743,7 +743,7 @@ DETAIL:  Synchronization could lead to data loss, because the remote slot needs
     </link>
     subdirectory of the PostgreSQL source tree.
    </para>
-   <sect2 id="logicaldecoding-output-init">
+   <sect2 id="logicaldecoding-output-init" xreflabel="Initialization Function">
     <title>Initialization Function</title>
     <indexterm zone="logicaldecoding-output-init">
      <primary>_PG_output_plugin_init</primary>
@@ -816,7 +816,7 @@ typedef void (*LogicalOutputPluginInit) (struct OutputPluginCallbacks *cb);
     </para>
    </sect2>
 
-   <sect2 id="logicaldecoding-capabilities">
+   <sect2 id="logicaldecoding-capabilities" xreflabel="Capabilities">
     <title>Capabilities</title>
 
     <para>
@@ -839,7 +839,7 @@ CREATE TABLE another_catalog_table(data text) WITH (user_catalog_table = true);
     </para>
    </sect2>
 
-   <sect2 id="logicaldecoding-output-mode">
+   <sect2 id="logicaldecoding-output-mode" xreflabel="Output Modes">
     <title>Output Modes</title>
 
     <para>
@@ -858,7 +858,7 @@ CREATE TABLE another_catalog_table(data text) WITH (user_catalog_table = true);
     </para>
    </sect2>
 
-   <sect2 id="logicaldecoding-output-plugin-callbacks">
+   <sect2 id="logicaldecoding-output-plugin-callbacks" xreflabel="Output Plugin Callbacks">
     <title>Output Plugin Callbacks</title>
 
     <para>
@@ -898,7 +898,7 @@ CREATE TABLE another_catalog_table(data text) WITH (user_catalog_table = true);
      </para>
     </note>
 
-    <sect3 id="logicaldecoding-output-plugin-startup">
+    <sect3 id="logicaldecoding-output-plugin-startup" xreflabel="Startup Callback">
      <title>Startup Callback</title>
      <para>
       The optional <function>startup_cb</function> callback is called whenever
@@ -938,7 +938,7 @@ typedef struct OutputPluginOptions
      </para>
     </sect3>
 
-    <sect3 id="logicaldecoding-output-plugin-shutdown">
+    <sect3 id="logicaldecoding-output-plugin-shutdown" xreflabel="Shutdown Callback">
      <title>Shutdown Callback</title>
 
      <para>
@@ -952,7 +952,7 @@ typedef void (*LogicalDecodeShutdownCB) (struct LogicalDecodingContext *ctx);
      </para>
     </sect3>
 
-    <sect3 id="logicaldecoding-output-plugin-begin">
+    <sect3 id="logicaldecoding-output-plugin-begin" xreflabel="Transaction Begin Callback">
      <title>Transaction Begin Callback</title>
 
      <para>
@@ -969,7 +969,7 @@ typedef void (*LogicalDecodeBeginCB) (struct LogicalDecodingContext *ctx,
      </para>
     </sect3>
 
-    <sect3 id="logicaldecoding-output-plugin-commit">
+    <sect3 id="logicaldecoding-output-plugin-commit" xreflabel="Transaction End Callback">
      <title>Transaction End Callback</title>
 
      <para>
@@ -986,7 +986,7 @@ typedef void (*LogicalDecodeCommitCB) (struct LogicalDecodingContext *ctx,
      </para>
     </sect3>
 
-    <sect3 id="logicaldecoding-output-plugin-change">
+    <sect3 id="logicaldecoding-output-plugin-change" xreflabel="Change Callback">
      <title>Change Callback</title>
 
      <para>
@@ -1027,7 +1027,7 @@ typedef void (*LogicalDecodeChangeCB) (struct LogicalDecodingContext *ctx,
      </note>
     </sect3>
 
-    <sect3 id="logicaldecoding-output-plugin-truncate">
+    <sect3 id="logicaldecoding-output-plugin-truncate" xreflabel="Truncate Callback">
      <title>Truncate Callback</title>
 
      <para>
@@ -1049,7 +1049,7 @@ typedef void (*LogicalDecodeTruncateCB) (struct LogicalDecodingContext *ctx,
      </para>
     </sect3>
 
-     <sect3 id="logicaldecoding-output-plugin-filter-origin">
+     <sect3 id="logicaldecoding-output-plugin-filter-origin" xreflabel="Origin Filter Callback">
      <title>Origin Filter Callback</title>
 
      <para>
@@ -1078,7 +1078,7 @@ typedef bool (*LogicalDecodeFilterByOriginCB) (struct LogicalDecodingContext *ct
      </para>
      </sect3>
 
-    <sect3 id="logicaldecoding-output-plugin-message">
+    <sect3 id="logicaldecoding-output-plugin-message" xreflabel="Generic Message Callback">
      <title>Generic Message Callback</title>
 
      <para>
@@ -1117,7 +1117,7 @@ typedef void (*LogicalDecodeMessageCB) (struct LogicalDecodingContext *ctx,
      </para>
     </sect3>
 
-    <sect3 id="logicaldecoding-output-plugin-filter-prepare">
+    <sect3 id="logicaldecoding-output-plugin-filter-prepare" xreflabel="Prepare Filter Callback">
      <title>Prepare Filter Callback</title>
 
      <para>
@@ -1150,7 +1150,7 @@ typedef bool (*LogicalDecodeFilterPrepareCB) (struct LogicalDecodingContext *ctx
      </para>
      </sect3>
 
-    <sect3 id="logicaldecoding-output-plugin-begin-prepare">
+    <sect3 id="logicaldecoding-output-plugin-begin-prepare" xreflabel="Transaction Begin Prepare Callback">
      <title>Transaction Begin Prepare Callback</title>
 
      <para>
@@ -1168,7 +1168,7 @@ typedef void (*LogicalDecodeBeginPrepareCB) (struct LogicalDecodingContext *ctx,
      </para>
     </sect3>
 
-    <sect3 id="logicaldecoding-output-plugin-prepare">
+    <sect3 id="logicaldecoding-output-plugin-prepare" xreflabel="Transaction Prepare Callback">
      <title>Transaction Prepare Callback</title>
 
      <para>
@@ -1186,7 +1186,7 @@ typedef void (*LogicalDecodePrepareCB) (struct LogicalDecodingContext *ctx,
      </para>
     </sect3>
 
-    <sect3 id="logicaldecoding-output-plugin-commit-prepared">
+    <sect3 id="logicaldecoding-output-plugin-commit-prepared" xreflabel="Transaction Commit Prepared Callback">
      <title>Transaction Commit Prepared Callback</title>
 
      <para>
@@ -1202,7 +1202,7 @@ typedef void (*LogicalDecodeCommitPreparedCB) (struct LogicalDecodingContext *ct
      </para>
     </sect3>
 
-    <sect3 id="logicaldecoding-output-plugin-rollback-prepared">
+    <sect3 id="logicaldecoding-output-plugin-rollback-prepared" xreflabel="Transaction Rollback Prepared Callback">
      <title>Transaction Rollback Prepared Callback</title>
 
      <para>
@@ -1225,7 +1225,7 @@ typedef void (*LogicalDecodeRollbackPreparedCB) (struct LogicalDecodingContext *
      </para>
     </sect3>
 
-    <sect3 id="logicaldecoding-output-plugin-stream-start">
+    <sect3 id="logicaldecoding-output-plugin-stream-start" xreflabel="Stream Start Callback">
      <title>Stream Start Callback</title>
      <para>
       The required <function>stream_start_cb</function> callback is called when
@@ -1237,7 +1237,7 @@ typedef void (*LogicalDecodeStreamStartCB) (struct LogicalDecodingContext *ctx,
      </para>
     </sect3>
 
-    <sect3 id="logicaldecoding-output-plugin-stream-stop">
+    <sect3 id="logicaldecoding-output-plugin-stream-stop" xreflabel="Stream Stop Callback">
      <title>Stream Stop Callback</title>
      <para>
       The required <function>stream_stop_cb</function> callback is called when
@@ -1249,7 +1249,7 @@ typedef void (*LogicalDecodeStreamStopCB) (struct LogicalDecodingContext *ctx,
      </para>
     </sect3>
 
-    <sect3 id="logicaldecoding-output-plugin-stream-abort">
+    <sect3 id="logicaldecoding-output-plugin-stream-abort" xreflabel="Stream Abort Callback">
      <title>Stream Abort Callback</title>
      <para>
       The required <function>stream_abort_cb</function> callback is called to
@@ -1262,7 +1262,7 @@ typedef void (*LogicalDecodeStreamAbortCB) (struct LogicalDecodingContext *ctx,
      </para>
     </sect3>
 
-    <sect3 id="logicaldecoding-output-plugin-stream-prepare">
+    <sect3 id="logicaldecoding-output-plugin-stream-prepare" xreflabel="Stream Prepare Callback">
      <title>Stream Prepare Callback</title>
      <para>
       The <function>stream_prepare_cb</function> callback is called to prepare
@@ -1277,7 +1277,7 @@ typedef void (*LogicalDecodeStreamPrepareCB) (struct LogicalDecodingContext *ctx
      </para>
     </sect3>
 
-    <sect3 id="logicaldecoding-output-plugin-stream-commit">
+    <sect3 id="logicaldecoding-output-plugin-stream-commit" xreflabel="Stream Commit Callback">
      <title>Stream Commit Callback</title>
      <para>
       The required <function>stream_commit_cb</function> callback is called to
@@ -1290,7 +1290,7 @@ typedef void (*LogicalDecodeStreamCommitCB) (struct LogicalDecodingContext *ctx,
      </para>
     </sect3>
 
-    <sect3 id="logicaldecoding-output-plugin-stream-change">
+    <sect3 id="logicaldecoding-output-plugin-stream-change" xreflabel="Stream Change Callback">
      <title>Stream Change Callback</title>
      <para>
       The required <function>stream_change_cb</function> callback is called
@@ -1307,7 +1307,7 @@ typedef void (*LogicalDecodeStreamChangeCB) (struct LogicalDecodingContext *ctx,
      </para>
     </sect3>
 
-    <sect3 id="logicaldecoding-output-plugin-stream-message">
+    <sect3 id="logicaldecoding-output-plugin-stream-message" xreflabel="Stream Message Callback">
      <title>Stream Message Callback</title>
      <para>
       The optional <function>stream_message_cb</function> callback is called when
@@ -1328,7 +1328,7 @@ typedef void (*LogicalDecodeStreamMessageCB) (struct LogicalDecodingContext *ctx
      </para>
     </sect3>
 
-    <sect3 id="logicaldecoding-output-plugin-stream-truncate">
+    <sect3 id="logicaldecoding-output-plugin-stream-truncate" xreflabel="Stream Truncate Callback">
      <title>Stream Truncate Callback</title>
      <para>
       The optional <function>stream_truncate_cb</function> callback is called
@@ -1353,7 +1353,7 @@ typedef void (*LogicalDecodeStreamTruncateCB) (struct LogicalDecodingContext *ct
 
    </sect2>
 
-   <sect2 id="logicaldecoding-output-plugin-output">
+   <sect2 id="logicaldecoding-output-plugin-output" xreflabel="Functions for Producing Output">
     <title>Functions for Producing Output</title>
 
     <para>
@@ -1381,7 +1381,7 @@ OutputPluginWrite(ctx, true);
    </sect2>
   </sect1>
 
-  <sect1 id="logicaldecoding-writer">
+  <sect1 id="logicaldecoding-writer" xreflabel="Logical Decoding Output Writers">
    <title>Logical Decoding Output Writers</title>
 
    <para>
@@ -1394,9 +1394,9 @@ OutputPluginWrite(ctx, true);
    </para>
   </sect1>
 
-  <sect1 id="logicaldecoding-synchronous">
+  <sect1 id="logicaldecoding-synchronous" xreflabel="Synchronous Replication Support for Logical Decoding">
    <title>Synchronous Replication Support for Logical Decoding</title>
-   <sect2 id="logicaldecoding-synchronous-overview">
+   <sect2 id="logicaldecoding-synchronous-overview" xreflabel="Overview">
     <title>Overview</title>
 
     <para>
@@ -1422,7 +1422,7 @@ OutputPluginWrite(ctx, true);
     </note>
    </sect2>
 
-   <sect2 id="logicaldecoding-synchronous-caveats">
+   <sect2 id="logicaldecoding-synchronous-caveats" xreflabel="Caveats">
     <title>Caveats</title>
 
     <para>
@@ -1480,7 +1480,7 @@ OutputPluginWrite(ctx, true);
    </sect2>
   </sect1>
 
-  <sect1 id="logicaldecoding-streaming">
+  <sect1 id="logicaldecoding-streaming" xreflabel="Streaming of Large Transactions for Logical Decoding">
    <title>Streaming of Large Transactions for Logical Decoding</title>
 
    <para>
@@ -1585,7 +1585,7 @@ commit_prepared_cb(...);  &lt;-- commit of the prepared transaction
 
   </sect1>
 
-  <sect1 id="logicaldecoding-two-phase-commits">
+  <sect1 id="logicaldecoding-two-phase-commits" xreflabel="Two-phase Commit Support for Logical Decoding">
    <title>Two-phase Commit Support for Logical Decoding</title>
 
    <para>
diff --git a/doc/src/sgml/ltree.sgml b/doc/src/sgml/ltree.sgml
index ff3c227727b..312486e51b0 100644
--- a/doc/src/sgml/ltree.sgml
+++ b/doc/src/sgml/ltree.sgml
@@ -19,7 +19,7 @@
   on the current database.
  </para>
 
- <sect2 id="ltree-definitions">
+ <sect2 id="ltree-definitions" xreflabel="Definitions">
   <title>Definitions</title>
 
   <para>
@@ -188,7 +188,7 @@ Europe &amp; Russia*@ &amp; !Transportation
   </para>
  </sect2>
 
- <sect2 id="ltree-ops-funcs">
+ <sect2 id="ltree-ops-funcs" xreflabel="Operators and Functions">
   <title>Operators and Functions</title>
 
   <para>
@@ -608,7 +608,7 @@ Europe &amp; Russia*@ &amp; !Transportation
   </table>
  </sect2>
 
- <sect2 id="ltree-indexes">
+ <sect2 id="ltree-indexes" xreflabel="Indexes">
   <title>Indexes</title>
   <para>
    <filename>ltree</filename> supports several types of indexes that can speed
@@ -694,7 +694,7 @@ CREATE INDEX path_gist_idx ON test USING GIST (array_path gist__ltree_ops(siglen
   </itemizedlist>
  </sect2>
 
- <sect2 id="ltree-example">
+ <sect2 id="ltree-example" xreflabel="Example">
   <title>Example</title>
 
   <para>
@@ -832,7 +832,7 @@ ltreetest=&gt; SELECT ins_label(path,2,'Space') FROM test WHERE path &lt;@ 'Top.
   </para>
  </sect2>
 
- <sect2 id="ltree-transforms">
+ <sect2 id="ltree-transforms" xreflabel="Transforms">
   <title>Transforms</title>
 
   <para>
@@ -843,7 +843,7 @@ ltreetest=&gt; SELECT ins_label(path,2,'Space') FROM test WHERE path &lt;@ 'Top.
   </para>
  </sect2>
 
- <sect2 id="ltree-authors">
+ <sect2 id="ltree-authors" xreflabel="Authors">
   <title>Authors</title>
 
   <para>
